import java.util.ArrayList;

public class Fou extends Piece {
    public Fou(String coul) {
        super(coul);
    }

    @Override
    public ArrayList<Case> getDepPossibles(Echiquier ech) {

        ArrayList<Case> depPossible = new ArrayList<>();
        int caseBas = this.getL()+1;
        int caseHaut = this.getL()-1;
        int caseDroite = this.getC()+1;
        int caseGauche = this.getC()-1;
        Case caseLibre;


        /*HAUT DROITE*/

        while (ech.caseExiste(caseHaut,caseDroite)){
            if(ech.getPiece(caseHaut,caseDroite) == null){
                caseLibre = new Case(caseHaut,caseDroite);
                depPossible.add(caseLibre);
                caseHaut --;
                caseDroite ++;
            }else{
                if (!ech.getPiece(caseHaut,caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseDroite);
                    depPossible.add(caseLibre);
                    break;
                }
            }
        }
        caseHaut = this.getL()-1;
        caseDroite = this.getC()+1;


        /*BAS DROITE*/
        while (ech.caseExiste(caseBas,caseDroite)){
            if(ech.getPiece(caseBas,caseDroite) == null){
                caseLibre = new Case(caseBas,caseDroite);
                depPossible.add(caseLibre);
                caseBas ++;
                caseDroite ++;
            }else{
                if (!ech.getPiece(caseBas,caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseDroite);
                    depPossible.add(caseLibre);
                    break;
                }
            }
        }
        caseBas = this.getL()+1;
        caseDroite = this.getC()+1;



        /*BAS GAUCHE*/
        while (ech.caseExiste(caseBas,caseGauche)){
            if(ech.getPiece(caseBas,caseGauche) == null){
                caseLibre = new Case(caseBas,caseGauche);
                depPossible.add(caseLibre);
                caseBas ++;
                caseGauche --;
            }else{
                if (!ech.getPiece(caseBas,caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseGauche);
                    depPossible.add(caseLibre);
                    break;
                }
            }
        }
        caseBas = this.getL()+1;
        caseGauche = this.getC()-1;


        /*HAUT GAUCHE*/
        caseHaut = this.getL()-1;
        caseGauche = this.getC()-1;
        while (ech.caseExiste(caseHaut,caseGauche)){
            if(ech.getPiece(caseHaut,caseGauche) == null){
                caseLibre = new Case(caseHaut,caseGauche);
                depPossible.add(caseLibre);
                caseHaut --;
                caseGauche --;
            }else{
                if (!ech.getPiece(caseHaut,caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseGauche);
                    depPossible.add(caseLibre);
                    //break;
                }
            }
        }
        caseHaut = this.getL()-1;
        caseGauche = this.getC()-1;

        return depPossible;
    }

    @Override
    public String toString() {
        String nom = null;
        if (getCoul() == BLANC){
            nom = "FB";
        }else {
            nom = "FN";
        }
        return nom;
    }
}
