import java.util.ArrayList;

public class Reine extends Piece {
    public Reine(String coul) {
        super(coul);
    }

    @Override
    public ArrayList<Case> getDepPossibles(Echiquier ech) {
        ArrayList<Case> depPossible = new ArrayList<>();
        int caseBas = this.getL()+1;
        int caseHaut = this.getL()-1;
        int caseDroite = this.getC()+1;
        int caseGauche = this.getC()-1;
        Case caseLibre;

        /*NORD*/
        while(ech.caseExiste(caseHaut, this.getC()) ){
            if( ech.getPiece(caseHaut,this.getC()) == null  ){
                caseLibre = new Case(caseHaut,this.getC());
                depPossible.add(caseLibre);
                caseHaut --;
            }else {
                if (ech.getPiece(caseHaut,this.getC()).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(caseHaut,this.getC());
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }
        caseHaut = this.getL()-1;

        /*NORD EST*/
        while (ech.caseExiste(caseHaut,caseDroite)){
            if(ech.getPiece(caseHaut,caseDroite) == null){
                caseLibre = new Case(caseHaut,caseDroite);
                depPossible.add(caseLibre);
                caseHaut --;
                caseDroite ++;
            }else{
                if (!ech.getPiece(caseHaut,caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseDroite);
                    depPossible.add(caseLibre);
                    break;
                }
            }
        }
        caseHaut = this.getL()-1;
        caseDroite = this.getC()+1;

        /*EST*/
        while(ech.caseExiste(this.getL(), caseDroite) ){
            if( ech.getPiece(this.getL(),caseDroite) == null  ){
                caseLibre = new Case(this.getL(),caseDroite);
                depPossible.add(caseLibre);
                caseDroite ++;
            }else {
                if (ech.getPiece(this.getL(),caseDroite).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(this.getL(),caseDroite);
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }
        caseDroite = this.getC()+1;

        /*SUD EST*/
       while (ech.caseExiste(caseBas,caseDroite)){
            if(ech.getPiece(caseBas,caseDroite) == null){
                caseLibre = new Case(caseBas,caseDroite);
                depPossible.add(caseLibre);
                caseBas ++;
                caseDroite ++;
            }else{
                if (!ech.getPiece(caseBas,caseDroite).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseDroite);
                    depPossible.add(caseLibre);
                    break;
                }
            }
        }
        caseBas = this.getL()+1;
        caseDroite = this.getC()+1;

        /*SUD*/
        while(ech.caseExiste(caseBas, this.getC()) ){
            if( ech.getPiece(caseBas,this.getC()) == null  ){
                caseLibre = new Case(caseBas,this.getC());
                depPossible.add(caseLibre);
                caseBas ++;
            }else {
                if (ech.getPiece(caseBas,this.getC()).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(caseBas,this.getC());
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }
        caseBas = this.getL()+1;

        /*SUD OUEST*/
        while (ech.caseExiste(caseBas,caseGauche)){
            if(ech.getPiece(caseBas,caseGauche) == null){
                caseLibre = new Case(caseBas,caseGauche);
                depPossible.add(caseLibre);
                caseBas ++;
                caseGauche --;
            }else{
                if (!ech.getPiece(caseBas,caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseBas,caseGauche);
                    depPossible.add(caseLibre);
                    break;
                }
            }
        }
        caseBas = this.getL()+1;
        caseGauche = this.getC()-1;

        /*OUEST*/
        while(ech.caseExiste(this.getL(), caseGauche) ){
            if( ech.getPiece(this.getL(),caseGauche) == null  ){
                caseLibre = new Case(this.getL(),caseGauche);
                depPossible.add(caseLibre);
                caseGauche --;
            }else {
                if (ech.getPiece(this.getL(),caseGauche).getCoul() == this.getCoul()){
                    break;
                } else {
                    caseLibre = new Case(this.getL(),caseGauche);
                    depPossible.add(caseLibre);
                    break;
                }

            }

        }
        caseGauche = this.getC()-1;

        /*NORD OUEST*/
        caseHaut = this.getL()-1;
        caseGauche = this.getC()-1;
        while (ech.caseExiste(caseHaut,caseGauche)){
            if(ech.getPiece(caseHaut,caseGauche) == null){
                caseLibre = new Case(caseHaut,caseGauche);
                depPossible.add(caseLibre);
                caseHaut --;
                caseGauche --;
            }else{
                if (!ech.getPiece(caseHaut,caseGauche).getCoul().equals(this.getCoul())){
                    caseLibre = new Case(caseHaut,caseGauche);
                    depPossible.add(caseLibre);
                    //break;
                }
            }
        }


        return depPossible;
    }

    @Override
    public String toString() {
        String nom = null;
        if (getCoul() == BLANC){
            nom = "ReB";
        }else {
            nom = "ReN";
        }
        return nom;

    }
}
